<h2>{#LOGIN_CHANGE_DETAILS#}</h2>
<p class="text-muted">{#LOGIN_DETAILS_INFO#}</p>

{if $errors}
	<div class="row" id="user-info">
		<div class="col-12">
			<p>{#LOGIN_ERRORS#}</p>

            {foreach from=$errors item=error}
				<div class="alert alert-danger alert-dismissible fade show" role="alert">
                    {$error}
					<button type="button" class="close" data-dismiss="alert" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
            {/foreach}

		</div>
	</div>
{/if}

<form method="post" action="{$ABS_PATH}index.php?module=login&action=profile">
	<input type="hidden" name="sub" value="update" />
	<div class="row" id="user-info">
		<div class="col-12">
			<div class="form-row">
				<div class="form-group col-md-6">
					<label for="firstname">{#LOGIN_YOUR_FIRSTNAME#}</label>
					<input name="firstname" type="text" class="form-control" id="firstname" placeholder="" value="{$smarty.request.firstname|default:$row.firstname|escape|stripslashes}">
				</div>
				<div class="form-group col-md-6">
					<label for="lastname">{#LOGIN_YOUR_LASTNAME#}</label>
					<input name="lastname" type="text" class="form-control" id="lastname" placeholder="" value="{$smarty.request.lastname|default:$row.lastname|escape|stripslashes}">
				</div>
			</div>
			<div class="form-row">
				<div class="form-group col-md-6">
					<label for="email">{#LOGIN_YOUR_MAIL#}</label>
					<input name="email" type="email" class="form-control" id="email" placeholder="" value="{$smarty.request.email|default:$row.email|escape|stripslashes}">
				</div>
				<div class="form-group col-md-6">
					<label for="birthday">{#LOGIN_YOUR_BIRTHDAY#} {#LOGIN_DATE_FORMAT#}</label>
					<input name="birthday" type="text" class="form-control" id="birthday" placeholder="" value="{$smarty.request.birthday|default:$row.birthday|escape|stripslashes}">
				</div>
			</div>
			<div class="form-group">
				<label for="street">{#LOGIN_YOUR_STREET#}</label>
				<input name="street" type="text" class="form-control" id="street" placeholder="" value="{$smarty.request.street|default:$row.street|escape|stripslashes}">
			</div>
			<div class="form-group">
				<label for="street_nr">{#LOGIN_YOUR_HOUSE#}</label>
				<input name="street_nr" type="text" class="form-control" id="street_nr" placeholder="" value="{$smarty.request.street_nr|default:$row.street_nr|escape|stripslashes}">
			</div>
			<div class="form-row">
				<div class="form-group col-md-5">
					<label for="city">{#LOGIN_YOUR_TOWN#}</label>
					<input name="city" type="text" class="form-control" id="city" value="{$smarty.request.city|default:$row.city|escape|stripslashes}">
				</div>
				<div class="form-group col-md-4">
					<label for="country">{#LOGIN_YOUR_COUNTRY#}</label>
					<select id="country" class="form-control" name="country">
                        {assign var=uc value=$row->country|default:$smarty.session.user_language|lower}
                        {foreach from=$available_countries item=land}
							<option value="{$land->country_code}"{if $land->country_code == $smarty.request.country|default:$row.country|default:$smarty.session.user_language} selected="selected" {/if}>{$land->country_name}</option>
                        {/foreach}
					</select>
				</div>
				<div class="form-group col-md-3">
					<label for="zipcode">{#LOGIN_YOUR_ZIP#}</label>
					<input name="zipcode" type="text" class="form-control" id="zipcode" value="{$smarty.request.zipcode|default:$row.zipcode|escape|stripslashes}">
				</div>
			</div>
			<div class="form-row">
				<div class="form-group col-md-6">
					<label for="phone">{#LOGIN_YOUR_PHONE#}</label>
					<input name="phone" type="text" class="form-control" id="phone" placeholder="" value="{$smarty.request.phone|default:$row.phone|escape|stripslashes}">
				</div>
				<div class="form-group col-md-6">
					<label for="company">{#LOGIN_YOUR_COMPANY#}</label>
					<input name="company" type="text" class="form-control" id="company" placeholder="" value="{$smarty.request.company|default:$row.company|escape|stripslashes}">
				</div>
			</div>

			<button type="submit" class="btn btn-primary">{#LOGIN_BUTTON_CHANGE#}</button>
		</div>
	</div>
</form>
